"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validationMixin = void 0;
const clone_class_1 = require("clone-class");
const wechaty_puppet_1 = require("wechaty-puppet");
const validationMixin = (mixinBase) => () => {
    wechaty_puppet_1.log.verbose('ValidationMixin', 'validationMixin(%s)', mixinBase.name);
    const instanceOfUserClass = (0, clone_class_1.looseInstanceOfClass)(mixinBase);
    const interfaceOfUserClass = (0, clone_class_1.interfaceOfClass)(mixinBase)();
    const validUserClass = (o) => {
        if (instanceOfUserClass(o)) {
            // console.info('instanceOfUserClass(o) true')
            return true;
        }
        else if (interfaceOfUserClass(o)) {
            // console.info('interfaceOfUserClass(o): true')
            return true;
        }
        return false;
    };
    class ValidationUserClass extends mixinBase {
        static valid = validUserClass;
        static validInstance = instanceOfUserClass;
        static validInterface = interfaceOfUserClass;
    }
    return ValidationUserClass;
};
exports.validationMixin = validationMixin;
//# sourceMappingURL=validation.js.map