"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DelayImpl = void 0;
const validation_js_1 = require("../user-mixins/validation.js");
const wechatify_js_1 = require("../user-mixins/wechatify.js");
class DelayMixin extends (0, wechatify_js_1.wechatifyMixinBase)() {
    milliseconds;
    static create(milliseconds) {
        return new DelayImpl(milliseconds);
    }
    constructor(milliseconds) {
        super();
        this.milliseconds = milliseconds;
    }
    wait() {
        return new Promise(resolve => {
            setTimeout(resolve, this.milliseconds);
        });
    }
}
class DelayImpl extends (0, validation_js_1.validationMixin)(DelayMixin)() {
}
exports.DelayImpl = DelayImpl;
//# sourceMappingURL=delay.js.map