"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FavoriteImpl = void 0;
/**
 *   Wechaty Chatbot SDK - https://github.com/wechaty/wechaty
 *
 *   @copyright 2016 Huan LI (李卓桓) <https://github.com/huan>, and
 *                   Wechaty Contributors <https://github.com/wechaty>.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */
const wechaty_puppet_1 = require("wechaty-puppet");
const validation_js_1 = require("../user-mixins/validation.js");
const wechatify_js_1 = require("../user-mixins/wechatify.js");
class FavoriteMixin extends (0, wechatify_js_1.wechatifyMixinBase)() {
    static list() {
        return [];
    }
    /**
     * Get tags for all favorites
     *
     * @static
     * @returns {Promise<TagInterface[]>}
     * @example
     * const tags = await wechaty.Favorite.tags()
     */
    static async tags() {
        wechaty_puppet_1.log.verbose('Favorite', 'static tags() for %s', this);
        // TODO:
        // try {
        //   const tagIdList = await this.puppet.tagFavoriteList()
        //   const tagList = tagIdList.map(id => this.wechaty.Tag.load(id))
        //   return tagList
        // } catch (e) {
        //   log.error('Favorite', 'static tags() exception: %s', e.message)
        //   return []
        // }
        return [];
    }
    /*
     * @hideconstructor
     */
    constructor() {
        super();
    }
    async tags() {
        // TODO: implmente this method
        return [];
    }
    async findAll() {
        //
    }
}
class FavoriteImpl extends (0, validation_js_1.validationMixin)(FavoriteMixin)() {
}
exports.FavoriteImpl = FavoriteImpl;
//# sourceMappingURL=favorite.js.map