/**
 *   Wechaty Chatbot SDK - https://github.com/wechaty/wechaty
 *
 *   @copyright 2016 Huan LI (李卓桓) <https://github.com/huan>, and
 *                   Wechaty Contributors <https://github.com/wechaty>.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */
declare const PUPPET_DEPENDENCIES: {
    /**
     * The following puppets were DEPRECATED before 2020
     */
    /**
     * Deprecated History:
     *  https://github.com/wechaty/puppet-service-providers/issues/11
     */
    /**
     * Wechaty Internal Puppets: dependency by package.json
     *
     *  Huan(202108): DO NOT REMOVE THE SPECIFIC VERSIONS BELOW
     *    All the internal puppets which have already depended in package.json
     *    MUST be listed below with their correct version number (ranges)
     *    because the `bin/puppet-install.ts` will use those version
     *    to install all them inside the Docker
     */
    'wechaty-puppet-service': string;
    'wechaty-puppet-mock': string;
    /**
     * WeChat Puppets
     */
    'wechaty-puppet-wechat': string;
    'wechaty-puppet-wechat4u': string;
    'wechaty-puppet-padlocal': string;
    'wechaty-puppet-xp': string;
    'wechaty-puppet-oicq': string;
    'wechaty-puppet-official-account': string;
    /**
     * Non-WeChat External Puppets
     */
    'wechaty-puppet-gitter': string;
    'wechaty-puppet-lark': string;
    'wechaty-puppet-whatsapp': string;
    'wechaty-puppet-walnut': string;
    /**
     * Scoped puppets (private)
     */
    '@juzibot/wechaty-puppet-donut': string;
    '@juzibot/wechaty-puppet-wxwork': string;
};
declare type PuppetModuleName = keyof typeof PUPPET_DEPENDENCIES;
declare const isPuppetModuleName: (name: string) => name is "wechaty-puppet-service" | "wechaty-puppet-mock" | "wechaty-puppet-wechat" | "wechaty-puppet-wechat4u" | "wechaty-puppet-padlocal" | "wechaty-puppet-xp" | "wechaty-puppet-oicq" | "wechaty-puppet-official-account" | "wechaty-puppet-gitter" | "wechaty-puppet-lark" | "wechaty-puppet-whatsapp" | "wechaty-puppet-walnut" | "@juzibot/wechaty-puppet-donut" | "@juzibot/wechaty-puppet-wxwork";
/**
 * Updates:
 *  - Huan(202004): we change default puppet from puppet-service -> puppet-wechat (with UOS support)
 *  - Huan(202009): use puppet service as default
 *  - Huan(202201): use puppet-wechat4u as default
 */
declare const PUPPET_NAME_DEFAULT: PuppetModuleName;
export type { PuppetModuleName, };
export { PUPPET_DEPENDENCIES, PUPPET_NAME_DEFAULT, isPuppetModuleName, };
//# sourceMappingURL=puppet-config.d.ts.map