/**
 *   Wechaty Chatbot SDK - https://github.com/wechaty/wechaty
 *
 *   @copyright 2016 Huan LI (李卓桓) <https://github.com/huan>, and
 *                   Wechaty Contributors <https://github.com/wechaty>.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */
import type { Constructor } from 'clone-class';
declare const DelayMixin_base: ((abstract new (...args: any[]) => {
    readonly wechaty: import("../wechaty/wechaty-impl.js").WechatyInterface;
}) & {
    readonly wechaty: import("../wechaty/wechaty-impl.js").WechatyInterface;
}) & {
    new (): {};
};
declare class DelayMixin extends DelayMixin_base {
    milliseconds: number;
    static create(milliseconds: number): DelayInterface;
    constructor(milliseconds: number);
    wait(): Promise<void>;
}
declare const DelayImpl_base: {
    new (...args: any[]): {};
    valid: (o: any) => o is DelayInterface;
    validInstance: (target: any) => target is DelayMixin;
    validInterface: (target: any) => target is DelayInterface;
} & typeof DelayMixin;
declare class DelayImpl extends DelayImpl_base {
}
interface DelayInterface extends DelayImpl {
}
declare type DelayConstructor = Constructor<DelayInterface, typeof DelayImpl>;
export type { DelayConstructor, DelayInterface, };
export { DelayImpl, };
//# sourceMappingURL=delay.d.ts.map