import { validationMixin } from '../user-mixins/validation.js';
import { wechatifyMixinBase, } from '../user-mixins/wechatify.js';
class DelayMixin extends wechatifyMixinBase() {
    milliseconds;
    static create(milliseconds) {
        return new DelayImpl(milliseconds);
    }
    constructor(milliseconds) {
        super();
        this.milliseconds = milliseconds;
    }
    wait() {
        return new Promise(resolve => {
            setTimeout(resolve, this.milliseconds);
        });
    }
}
class DelayImpl extends validationMixin(DelayMixin)() {
}
export { DelayImpl, };
//# sourceMappingURL=delay.js.map