/**
 *   Wechaty Chatbot SDK - https://github.com/wechaty/wechaty
 *
 *   @copyright 2016 Huan LI (李卓桓) <https://github.com/huan>, and
 *                   Wechaty Contributors <https://github.com/wechaty>.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */
import type { Constructor } from 'clone-class';
declare const MoneyMixin_base: ((abstract new (...args: any[]) => {
    readonly wechaty: import("../wechaty/wechaty-impl.js").WechatyInterface;
}) & {
    readonly wechaty: import("../wechaty/wechaty-impl.js").WechatyInterface;
}) & {
    new (): {};
};
declare class MoneyMixin extends MoneyMixin_base {
    constructor();
}
declare const MoneyImpl_base: {
    new (...args: any[]): {};
    valid: (o: any) => o is MoneyInterface;
    validInstance: (target: any) => target is MoneyMixin;
    validInterface: (target: any) => target is MoneyInterface;
} & typeof MoneyMixin;
declare class MoneyImpl extends MoneyImpl_base {
}
interface MoneyInterface extends MoneyImpl {
}
declare type MoneyConstructor = Constructor<MoneyInterface, typeof MoneyImpl>;
export type { MoneyConstructor, MoneyInterface, };
export { MoneyImpl, };
//# sourceMappingURL=money.d.ts.map