import * as PUPPET from 'wechaty-puppet';
import type { WechatyEventListeners } from '../schemas/mod.js';
import type { ContactSelfInterface } from '../user-modules/mod.js';
import type { WechatySkeleton } from '../wechaty/mod.js';
declare const loginMixin: <MixinBase extends typeof WechatySkeleton & ((abstract new (...args: any[]) => {
    __puppet?: PUPPET.impls.PuppetInterface | undefined;
    readonly puppet: PUPPET.impls.PuppetInterface;
    readonly __readyState: import("state-switch/dist/esm/src/interfaces").StateSwitchInterface;
    start(): Promise<void>;
    stop(): Promise<void>;
    ready(): Promise<void>;
    __initPuppetInstance(): Promise<void>;
    __setupPuppetEvents(puppet: PUPPET.impls.PuppetInterface): void;
    __wechatifiedContact?: import("../user-modules/contact.js").ContactConstructor | undefined;
    __wechatifiedContactSelf?: import("../user-modules/contact-self.js").ContactSelfConstructor | undefined;
    __wechatifiedDelay?: import("../user-modules/delay.js").DelayConstructor | undefined;
    __wechatifiedFriendship?: import("../user-modules/friendship.js").FriendshipConstructor | undefined;
    __wechatifiedImage?: import("../user-modules/image.js").ImageConstructor | undefined;
    __wechatifiedLocation?: import("../user-modules/location.js").LocationConstructor | undefined;
    __wechatifiedMessage?: import("../user-modules/message.js").MessageConstructor | undefined;
    __wechatifiedMiniProgram?: import("../user-modules/mini-program.js").MiniProgramConstructor | undefined;
    __wechatifiedPost?: import("../user-modules/post.js").PostConstructor | undefined;
    __wechatifiedRoom?: import("../user-modules/room.js").RoomConstructor | undefined;
    __wechatifiedRoomInvitation?: import("../user-modules/room-invitation.js").RoomInvitationConstructor | undefined;
    __wechatifiedTag?: import("../user-modules/tag.js").TagConstructor | undefined;
    __wechatifiedUrlLink?: import("../user-modules/url-link.js").UrlLinkConstructor | undefined;
    readonly Contact: import("../user-modules/contact.js").ContactConstructor;
    readonly ContactSelf: import("../user-modules/contact-self.js").ContactSelfConstructor;
    readonly Delay: import("../user-modules/delay.js").DelayConstructor;
    readonly Friendship: import("../user-modules/friendship.js").FriendshipConstructor;
    readonly Image: import("../user-modules/image.js").ImageConstructor;
    readonly Location: import("../user-modules/location.js").LocationConstructor;
    readonly Message: import("../user-modules/message.js").MessageConstructor;
    readonly MiniProgram: import("../user-modules/mini-program.js").MiniProgramConstructor;
    readonly Post: import("../user-modules/post.js").PostConstructor;
    readonly Room: import("../user-modules/room.js").RoomConstructor;
    readonly RoomInvitation: import("../user-modules/room-invitation.js").RoomInvitationConstructor;
    readonly Tag: import("../user-modules/tag.js").TagConstructor;
    readonly UrlLink: import("../user-modules/url-link.js").UrlLinkConstructor;
    __wechatifyUserModules(): void;
    readonly log: import("brolog/dist/esm/src/logger").Loggable;
    readonly id: string;
    __memory?: import("memory-card").MemoryCard | undefined;
    readonly memory: import("memory-card").MemoryCard;
    __options: import("../schemas/wechaty-options.js").WechatyOptions;
    on(event: "error" | "ready" | "login" | "start" | "stop" | "logout" | "room-invite" | "room-join" | "room-leave" | "room-topic" | "dong" | "friendship" | "heartbeat" | "message" | "post" | "puppet" | "scan", listener: (...args: any[]) => any): any;
    addListener<E extends keyof WechatyEventListeners>(event: E, listener: WechatyEventListeners[E]): any;
    once<E_1 extends keyof WechatyEventListeners>(event: E_1, listener: WechatyEventListeners[E_1]): any;
    prependListener<E_2 extends keyof WechatyEventListeners>(event: E_2, listener: WechatyEventListeners[E_2]): any;
    prependOnceListener<E_3 extends keyof WechatyEventListeners>(event: E_3, listener: WechatyEventListeners[E_3]): any;
    off<E_4 extends keyof WechatyEventListeners>(event: E_4, listener: WechatyEventListeners[E_4]): any;
    removeAllListeners<E_5 extends keyof WechatyEventListeners>(event?: E_5 | undefined): any;
    removeListener<E_6 extends keyof WechatyEventListeners>(event: E_6, listener: WechatyEventListeners[E_6]): any;
    emit: (<E_7 extends keyof WechatyEventListeners>(event: E_7, ...args: import("typed-emitter").Arguments<WechatyEventListeners[E_7]>) => boolean) & ((event: any, ...args: any) => boolean);
    eventNames(): (string | symbol)[];
    rawListeners<E_8 extends keyof WechatyEventListeners>(event: E_8): Function[];
    listeners<E_9 extends keyof WechatyEventListeners>(event: E_9): Function[];
    listenerCount<E_10 extends keyof WechatyEventListeners>(event: E_10): number;
    getMaxListeners(): number;
    setMaxListeners(maxListeners: number): any;
    __events: WechatyEventListeners;
    wrapAsync: import("gerror/dist/esm/src/wrap-async-error/wrap-async-error").WrapAsync;
    emitError(e: any): void;
    __io?: import("../io.js").Io | undefined;
    readonly io: import("../io.js").Io;
    __ioToken?: string | undefined;
}) & {
    readonly log: import("brolog/dist/esm/src/logger").Loggable;
}) & ((abstract new (...args: any[]) => {
    __wechatifiedContact?: import("../user-modules/contact.js").ContactConstructor | undefined;
    __wechatifiedContactSelf?: import("../user-modules/contact-self.js").ContactSelfConstructor | undefined;
    __wechatifiedDelay?: import("../user-modules/delay.js").DelayConstructor | undefined;
    __wechatifiedFriendship?: import("../user-modules/friendship.js").FriendshipConstructor | undefined;
    __wechatifiedImage?: import("../user-modules/image.js").ImageConstructor | undefined;
    __wechatifiedLocation?: import("../user-modules/location.js").LocationConstructor | undefined;
    __wechatifiedMessage?: import("../user-modules/message.js").MessageConstructor | undefined;
    __wechatifiedMiniProgram?: import("../user-modules/mini-program.js").MiniProgramConstructor | undefined;
    __wechatifiedPost?: import("../user-modules/post.js").PostConstructor | undefined;
    __wechatifiedRoom?: import("../user-modules/room.js").RoomConstructor | undefined;
    __wechatifiedRoomInvitation?: import("../user-modules/room-invitation.js").RoomInvitationConstructor | undefined;
    __wechatifiedTag?: import("../user-modules/tag.js").TagConstructor | undefined;
    __wechatifiedUrlLink?: import("../user-modules/url-link.js").UrlLinkConstructor | undefined;
    readonly Contact: import("../user-modules/contact.js").ContactConstructor;
    readonly ContactSelf: import("../user-modules/contact-self.js").ContactSelfConstructor;
    readonly Delay: import("../user-modules/delay.js").DelayConstructor;
    readonly Friendship: import("../user-modules/friendship.js").FriendshipConstructor;
    readonly Image: import("../user-modules/image.js").ImageConstructor;
    readonly Location: import("../user-modules/location.js").LocationConstructor;
    readonly Message: import("../user-modules/message.js").MessageConstructor;
    readonly MiniProgram: import("../user-modules/mini-program.js").MiniProgramConstructor;
    readonly Post: import("../user-modules/post.js").PostConstructor;
    readonly Room: import("../user-modules/room.js").RoomConstructor;
    readonly RoomInvitation: import("../user-modules/room-invitation.js").RoomInvitationConstructor;
    readonly Tag: import("../user-modules/tag.js").TagConstructor;
    readonly UrlLink: import("../user-modules/url-link.js").UrlLinkConstructor;
    start(): Promise<void>;
    __wechatifyUserModules(): void;
    readonly log: import("brolog/dist/esm/src/logger").Loggable;
    readonly id: string;
    __memory?: import("memory-card").MemoryCard | undefined;
    readonly memory: import("memory-card").MemoryCard;
    __options: import("../schemas/wechaty-options.js").WechatyOptions;
    stop(): Promise<void>;
    on(event: "error" | "ready" | "login" | "start" | "stop" | "logout" | "room-invite" | "room-join" | "room-leave" | "room-topic" | "dong" | "friendship" | "heartbeat" | "message" | "post" | "puppet" | "scan", listener: (...args: any[]) => any): any;
    addListener<E_11 extends keyof WechatyEventListeners>(event: E_11, listener: WechatyEventListeners[E_11]): any;
    once<E_12 extends keyof WechatyEventListeners>(event: E_12, listener: WechatyEventListeners[E_12]): any;
    prependListener<E_13 extends keyof WechatyEventListeners>(event: E_13, listener: WechatyEventListeners[E_13]): any;
    prependOnceListener<E_14 extends keyof WechatyEventListeners>(event: E_14, listener: WechatyEventListeners[E_14]): any;
    off<E_15 extends keyof WechatyEventListeners>(event: E_15, listener: WechatyEventListeners[E_15]): any;
    removeAllListeners<E_16 extends keyof WechatyEventListeners>(event?: E_16 | undefined): any;
    removeListener<E_17 extends keyof WechatyEventListeners>(event: E_17, listener: WechatyEventListeners[E_17]): any;
    emit<E_7 extends keyof WechatyEventListeners>(event: E_7, ...args: import("typed-emitter").Arguments<WechatyEventListeners[E_7]>): boolean;
    eventNames(): (string | symbol)[];
    rawListeners<E_8 extends keyof WechatyEventListeners>(event: E_8): Function[];
    listeners<E_9 extends keyof WechatyEventListeners>(event: E_9): Function[];
    listenerCount<E_10 extends keyof WechatyEventListeners>(event: E_10): number;
    getMaxListeners(): number;
    setMaxListeners(maxListeners: number): any;
    __events: WechatyEventListeners;
}) & {
    readonly log: import("brolog/dist/esm/src/logger").Loggable;
}) & ((abstract new (...args: any[]) => {
    wrapAsync: import("gerror/dist/esm/src/wrap-async-error/wrap-async-error").WrapAsync;
    emitError(e: any): void;
    /**
     * Get the logon / logoff state
     *
     * @returns {boolean}
     * @example
     * if (bot.isLoggedin) {
     *   console.log('Bot logged in')
     * } else {
     *   console.log('Bot not logged in')
     * }
     */
    emit(event: any, ...args: any): boolean;
    readonly log: import("brolog/dist/esm/src/logger").Loggable;
    readonly id: string;
    __memory?: import("memory-card").MemoryCard | undefined;
    readonly memory: import("memory-card").MemoryCard;
    __options: import("../schemas/wechaty-options.js").WechatyOptions;
    start(): Promise<void>;
    stop(): Promise<void>;
    on(event: "error" | "ready" | "login" | "start" | "stop" | "logout" | "room-invite" | "room-join" | "room-leave" | "room-topic" | "dong" | "friendship" | "heartbeat" | "message" | "post" | "puppet" | "scan", listener: (...args: any[]) => any): any;
    addListener<E_18 extends keyof WechatyEventListeners>(event: E_18, listener: WechatyEventListeners[E_18]): any;
    once<E_19 extends keyof WechatyEventListeners>(event: E_19, listener: WechatyEventListeners[E_19]): any;
    prependListener<E_20 extends keyof WechatyEventListeners>(event: E_20, listener: WechatyEventListeners[E_20]): any;
    prependOnceListener<E_21 extends keyof WechatyEventListeners>(event: E_21, listener: WechatyEventListeners[E_21]): any;
    off<E_22 extends keyof WechatyEventListeners>(event: E_22, listener: WechatyEventListeners[E_22]): any;
    removeAllListeners<E_23 extends keyof WechatyEventListeners>(event?: E_23 | undefined): any;
    removeListener<E_24 extends keyof WechatyEventListeners>(event: E_24, listener: WechatyEventListeners[E_24]): any;
    eventNames(): (string | symbol)[];
    rawListeners<E_8 extends keyof WechatyEventListeners>(event: E_8): Function[];
    listeners<E_9 extends keyof WechatyEventListeners>(event: E_9): Function[];
    listenerCount<E_10 extends keyof WechatyEventListeners>(event: E_10): number;
    getMaxListeners(): number;
    setMaxListeners(maxListeners: number): any;
    __events: WechatyEventListeners;
}) & {
    readonly log: import("brolog/dist/esm/src/logger").Loggable;
}) & ((abstract new (...args: any[]) => {
    __io?: import("../io.js").Io | undefined;
    readonly io: import("../io.js").Io;
    __ioToken?: string | undefined;
    start(): Promise<void>;
    stop(): Promise<void>;
    readonly log: import("brolog/dist/esm/src/logger").Loggable;
    readonly id: string;
    __memory?: import("memory-card").MemoryCard | undefined;
    readonly memory: import("memory-card").MemoryCard;
    __options: import("../schemas/wechaty-options.js").WechatyOptions;
    on(event: "error" | "ready" | "login" | "start" | "stop" | "logout" | "room-invite" | "room-join" | "room-leave" | "room-topic" | "dong" | "friendship" | "heartbeat" | "message" | "post" | "puppet" | "scan", listener: (...args: any[]) => any): any;
    addListener<E_25 extends keyof WechatyEventListeners>(event: E_25, listener: WechatyEventListeners[E_25]): any;
    once<E_26 extends keyof WechatyEventListeners>(event: E_26, listener: WechatyEventListeners[E_26]): any;
    prependListener<E_27 extends keyof WechatyEventListeners>(event: E_27, listener: WechatyEventListeners[E_27]): any;
    prependOnceListener<E_28 extends keyof WechatyEventListeners>(event: E_28, listener: WechatyEventListeners[E_28]): any;
    off<E_29 extends keyof WechatyEventListeners>(event: E_29, listener: WechatyEventListeners[E_29]): any;
    removeAllListeners<E_30 extends keyof WechatyEventListeners>(event?: E_30 | undefined): any;
    removeListener<E_31 extends keyof WechatyEventListeners>(event: E_31, listener: WechatyEventListeners[E_31]): any;
    emit: (<E_7 extends keyof WechatyEventListeners>(event: E_7, ...args: import("typed-emitter").Arguments<WechatyEventListeners[E_7]>) => boolean) & ((event: any, ...args: any) => boolean);
    eventNames(): (string | symbol)[];
    rawListeners<E_8 extends keyof WechatyEventListeners>(event: E_8): Function[];
    listeners<E_9 extends keyof WechatyEventListeners>(event: E_9): Function[];
    listenerCount<E_10 extends keyof WechatyEventListeners>(event: E_10): number;
    getMaxListeners(): number;
    setMaxListeners(maxListeners: number): any;
    __events: WechatyEventListeners;
    wrapAsync: import("gerror/dist/esm/src/wrap-async-error/wrap-async-error").WrapAsync;
    emitError(e: any): void;
}) & {
    readonly log: import("brolog/dist/esm/src/logger").Loggable;
})>(mixinBase: MixinBase) => ((abstract new (...args: any[]) => {
    __authQrCode?: string | undefined;
    readonly authQrCode: string | undefined;
    /**
     * The current user
     *
     * @returns {ContactSelfInterface}
     * @example
     * const contact = bot.currentUser
     * console.log(`Bot is ${contact.name()}`)
     */
    readonly currentUser: ContactSelfInterface;
    /**
     * Get the logon / logoff state
     *
     * @returns {boolean}
     * @example
     * if (bot.isLoggedin) {
     *   console.log('Bot logged in')
     * } else {
     *   console.log('Bot not logged in')
     * }
     */
    readonly isLoggedIn: boolean;
    __loginMixinStopCallbackList: (() => void)[];
    start(): Promise<void>;
    stop(): Promise<void>;
    /**
     * Logout the bot
     *
     * @returns {Promise<void>}
     * @example
     * await bot.logout()
     */
    logout(): Promise<void>;
    /**
     * @deprecated: use `isLoggedIn` property instead. will be removed after Dec 31, 2022
     */
    logonoff(): boolean;
    /**
     * Will be removed after Dec 31, 2022
     * @deprecated use {@link Wechaty#currentUser} instead
     */
    userSelf(): ContactSelfInterface;
    readonly log: import("brolog/dist/esm/src/logger").Loggable;
    readonly id: string;
    __memory?: import("memory-card").MemoryCard | undefined;
    readonly memory: import("memory-card").MemoryCard;
    __options: import("../schemas/wechaty-options.js").WechatyOptions;
    on(event: "error" | "ready" | "login" | "start" | "stop" | "logout" | "room-invite" | "room-join" | "room-leave" | "room-topic" | "dong" | "friendship" | "heartbeat" | "message" | "post" | "puppet" | "scan", listener: (...args: any[]) => any): any;
    addListener<E_32 extends keyof WechatyEventListeners>(event: E_32, listener: WechatyEventListeners[E_32]): any;
    once<E_33 extends keyof WechatyEventListeners>(event: E_33, listener: WechatyEventListeners[E_33]): any;
    prependListener<E_34 extends keyof WechatyEventListeners>(event: E_34, listener: WechatyEventListeners[E_34]): any;
    prependOnceListener<E_35 extends keyof WechatyEventListeners>(event: E_35, listener: WechatyEventListeners[E_35]): any;
    off<E_36 extends keyof WechatyEventListeners>(event: E_36, listener: WechatyEventListeners[E_36]): any;
    removeAllListeners<E_37 extends keyof WechatyEventListeners>(event?: E_37 | undefined): any;
    removeListener<E_38 extends keyof WechatyEventListeners>(event: E_38, listener: WechatyEventListeners[E_38]): any;
    emit: (<E_7 extends keyof WechatyEventListeners>(event: E_7, ...args: import("typed-emitter").Arguments<WechatyEventListeners[E_7]>) => boolean) & ((event: any, ...args: any) => boolean);
    eventNames(): (string | symbol)[];
    rawListeners<E_8 extends keyof WechatyEventListeners>(event: E_8): Function[];
    listeners<E_9 extends keyof WechatyEventListeners>(event: E_9): Function[];
    listenerCount<E_10 extends keyof WechatyEventListeners>(event: E_10): number;
    getMaxListeners(): number;
    setMaxListeners(maxListeners: number): any;
    __events: WechatyEventListeners;
    __puppet?: PUPPET.impls.PuppetInterface | undefined;
    readonly puppet: PUPPET.impls.PuppetInterface;
    readonly __readyState: import("state-switch/dist/esm/src/interfaces").StateSwitchInterface;
    ready(): Promise<void>;
    __initPuppetInstance(): Promise<void>;
    __setupPuppetEvents(puppet: PUPPET.impls.PuppetInterface): void;
    __wechatifiedContact?: import("../user-modules/contact.js").ContactConstructor | undefined;
    __wechatifiedContactSelf?: import("../user-modules/contact-self.js").ContactSelfConstructor | undefined;
    __wechatifiedDelay?: import("../user-modules/delay.js").DelayConstructor | undefined;
    __wechatifiedFriendship?: import("../user-modules/friendship.js").FriendshipConstructor | undefined;
    __wechatifiedImage?: import("../user-modules/image.js").ImageConstructor | undefined;
    __wechatifiedLocation?: import("../user-modules/location.js").LocationConstructor | undefined;
    __wechatifiedMessage?: import("../user-modules/message.js").MessageConstructor | undefined;
    __wechatifiedMiniProgram?: import("../user-modules/mini-program.js").MiniProgramConstructor | undefined;
    __wechatifiedPost?: import("../user-modules/post.js").PostConstructor | undefined;
    __wechatifiedRoom?: import("../user-modules/room.js").RoomConstructor | undefined;
    __wechatifiedRoomInvitation?: import("../user-modules/room-invitation.js").RoomInvitationConstructor | undefined;
    __wechatifiedTag?: import("../user-modules/tag.js").TagConstructor | undefined;
    __wechatifiedUrlLink?: import("../user-modules/url-link.js").UrlLinkConstructor | undefined;
    readonly Contact: import("../user-modules/contact.js").ContactConstructor;
    readonly ContactSelf: import("../user-modules/contact-self.js").ContactSelfConstructor;
    readonly Delay: import("../user-modules/delay.js").DelayConstructor;
    readonly Friendship: import("../user-modules/friendship.js").FriendshipConstructor;
    readonly Image: import("../user-modules/image.js").ImageConstructor;
    readonly Location: import("../user-modules/location.js").LocationConstructor;
    readonly Message: import("../user-modules/message.js").MessageConstructor;
    readonly MiniProgram: import("../user-modules/mini-program.js").MiniProgramConstructor;
    readonly Post: import("../user-modules/post.js").PostConstructor;
    readonly Room: import("../user-modules/room.js").RoomConstructor;
    readonly RoomInvitation: import("../user-modules/room-invitation.js").RoomInvitationConstructor;
    readonly Tag: import("../user-modules/tag.js").TagConstructor;
    readonly UrlLink: import("../user-modules/url-link.js").UrlLinkConstructor;
    __wechatifyUserModules(): void;
    wrapAsync: import("gerror/dist/esm/src/wrap-async-error/wrap-async-error").WrapAsync;
    emitError(e: any): void;
    __io?: import("../io.js").Io | undefined;
    readonly io: import("../io.js").Io;
    __ioToken?: string | undefined;
}) & {
    readonly log: import("brolog/dist/esm/src/logger").Loggable;
}) & MixinBase;
declare type LoginMixin = ReturnType<typeof loginMixin>;
declare type ProtectedPropertyLoginMixin = 'userSelf' | 'logonoff' | '__authQrCode' | '__loginMixinStopCallbackList';
export type { LoginMixin, ProtectedPropertyLoginMixin, };
export { loginMixin, };
//# sourceMappingURL=login-mixin.d.ts.map