#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
import { test } from 'tstest';
import { WechatyEventEmitter } from '../schemas/wechaty-events.js';
test('Wechaty interface', async (t) => {
    class WechatyImplementation extends WechatyEventEmitter {
        Contact;
        ContactSelf;
        Delay;
        Friendship;
        Image;
        Location;
        Message;
        MiniProgram;
        Post;
        Room;
        RoomInvitation;
        Tag;
        UrlLink;
        constructor() {
            super();
            // this.puppet
            this.Contact
                = this.ContactSelf
                    = this.Delay
                        = this.Friendship
                            = this.Image
                                = this.Location
                                    = this.Message
                                        = this.MiniProgram
                                            = this.Post
                                                = this.Room
                                                    = this.RoomInvitation
                                                        = this.Tag
                                                            = this.UrlLink
                                                                = {};
        }
    }
    const WechatyTest = WechatyImplementation;
    const w = new WechatyTest();
    w.on('message', (msg) => {
        msg.say('ok').catch(console.error);
    });
    t.ok(typeof WechatyImplementation, 'should no typing error');
});
test('ProtectedProperties', async (t) => {
    const noOneLeft = true;
    t.ok(noOneLeft, 'should match Wechaty properties for every protected property');
});
//# sourceMappingURL=wechaty-impl.spec.js.map