"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sayableToPayload = void 0;
const PUPPET = __importStar(require("wechaty-puppet"));
const wechaty_puppet_1 = require("wechaty-puppet");
const file_box_1 = require("file-box");
const mod_js_1 = require("../user-modules/mod.js");
async function sayableToPayload(sayable) {
    wechaty_puppet_1.log.verbose('Wechaty', 'sayableToPayload(%s)', sayable);
    if (typeof sayable === 'string') {
        return PUPPET.payloads.sayable.text(sayable);
    }
    else if (typeof sayable === 'number') {
        return PUPPET.payloads.sayable.text(String(sayable));
    }
    else if (mod_js_1.ContactImpl.valid(sayable)) {
        return PUPPET.payloads.sayable.contact(sayable.id);
    }
    else if (mod_js_1.DelayImpl.validInstance(sayable)) {
        return undefined;
    }
    else if (file_box_1.FileBox.valid(sayable)) {
        return PUPPET.payloads.sayable.attatchment(sayable);
    }
    else if (mod_js_1.LocationImpl.validInstance(sayable)) {
        return PUPPET.payloads.sayable.location(sayable.payload);
    }
    else if (mod_js_1.MessageImpl.valid(sayable)) {
        const messageSayable = await sayable.toSayable();
        if (!messageSayable) {
            return undefined;
        }
        return sayableToPayload(messageSayable);
    }
    else if (mod_js_1.MiniProgramImpl.validInstance(sayable)) {
        return PUPPET.payloads.sayable.miniProgram(sayable.payload);
    }
    else if (mod_js_1.PostImpl.validInstance(sayable)) {
        return PUPPET.payloads.sayable.post(sayable.payload);
    }
    else if (mod_js_1.UrlLinkImpl.validInstance(sayable)) {
        return PUPPET.payloads.sayable.url(sayable.payload);
    }
    else {
        wechaty_puppet_1.log.error('Wechaty', 'sayableToPayload() unsupported sayable: %s', sayable);
        return undefined;
    }
}
exports.sayableToPayload = sayableToPayload;
//# sourceMappingURL=sayable-to-payload.js.map